// PartBrowserPaneFrame.cpp : implementation file
//

#include "stdafx.h"
#include "GMEApp.h"
#include "GMEstd.h"
#include "GuiObject.h"
#include "PartBrowserPane.h"
#include "PartBrowserPaneFrame.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPartBrowserPaneFrame dialog


CPartBrowserPaneFrame::CPartBrowserPaneFrame(CWnd* pParent /*=NULL*/)
	: CDialog(CPartBrowserPaneFrame::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPartBrowserPaneFrame)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPartBrowserPaneFrame::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPartBrowserPaneFrame)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPartBrowserPaneFrame, CDialog)
	//{{AFX_MSG_MAP(CPartBrowserPaneFrame)
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CPartBrowserPaneFrame::Resize(RECT r)
{
	MoveWindow(&r);
	GetClientRect(&r);

	// ok, if there is the scroll bar there then we want to
	// increase the size, the number 16 is empirical 

	if( logicalHeight > pageHeight )
		r.right += 16;
	
	pane.MoveWindow(&r);
	BringWindowToTop();
	pane.BringWindowToTop();
	pane.Resize(r);
}

void CPartBrowserPaneFrame::SetScrollBar()
{
	if( scrollPos > (logicalHeight - pageHeight + 1) )
		scrollPos = (logicalHeight - pageHeight + 1);
	if( scrollPos < 0 )
		scrollPos = 0;

	if( logicalHeight > pageHeight )
	{
		SCROLLINFO si;
		si.cbSize = sizeof(SCROLLINFO);
		si.fMask = SIF_ALL;
		si.nPage = pageHeight;
		si.nMin = 0;
		si.nMax = logicalHeight;
		si.nPos = scrollPos;
		SetScrollInfo(SB_VERT, &si);
	}

	ShowScrollBar(SB_VERT, logicalHeight > pageHeight);
}

/////////////////////////////////////////////////////////////////////////////
// CPartBrowserPaneFrame message handlers

BOOL CPartBrowserPaneFrame::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	RECT r;
	GetClientRect(&r);
	pane.Create(NULL,"PartsPane",WS_CHILD | WS_VISIBLE | WS_BORDER,r,this,IDD_PARTBROWSER_PANE);
	pane.ModifyStyleEx(0,WS_EX_CLIENTEDGE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPartBrowserPaneFrame::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* /*pScrollBar*/) 
{
	int oldPos = scrollPos;

	switch(nSBCode) 
	{
	case SB_TOP:
		scrollPos = 0;
		break;
	case SB_BOTTOM:
		scrollPos = logicalHeight - pageHeight;
		break;
	case SB_ENDSCROLL:
		break;
	case SB_LINEDOWN:
		scrollPos += 20;
		break;
	case SB_LINEUP:
		scrollPos -= 20; 
		break;
	case SB_PAGEDOWN:
		scrollPos += 60;
		break;
	case SB_PAGEUP:
		scrollPos -= 60;
		break;
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		scrollPos = nPos;
		break;
	}

	if( scrollPos > (logicalHeight - pageHeight + 1) )
		scrollPos = (logicalHeight - pageHeight + 1);
	if( scrollPos < 0 )
		scrollPos = 0;

	pane.ScrollWindow(0, oldPos - scrollPos, NULL, NULL);
	SetScrollPos(SB_VERT, scrollPos);

//	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}
